#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Bullet.h"

constexpr byte InvalidCode = 0xff;
Sprite[SpriteCount] Sprites;


void InitSprites()
{
    HideAllSprites();
}

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->code = InvalidCode;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte code)
{
    ptr<Sprite> p;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    p->code = code;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->code = InvalidCode;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->code != InvalidCode) {
            ptr<byte> pVVram;
            byte c;
            c = p->code;
            if (p->code < Char_MyFighter) {
                pVVram = VVramPtr(p->x >> BulletShift, p->y >> BulletShift);
                *pVVram = c; 
            }
            else {
                pVVram = VVramPtr(p->x, p->y);
                if (p->x == VVramWidth - 1) {
                    repeat (2) {
                        *pVVram = c;
                        c += 2;
                        pVVram += VVramWidth;
                    }
                }
                else {
                    repeat (2) {
                        repeat (2) {
                            *pVVram = c;
                            ++c;
                            ++pVVram;
                        }
                        pVVram += VVramWidth - 2;
                    }
                }
            }
        }
    }
}
