include "Zeropage.inc"
include "Vram.inc"
include "VVram.inc"

ext VVram_
ext Chars_
ext WaitVSync

pSource equ ZW0
; pDestination equ ZW1
pVVram equ ZW2
pBackup equ ZW3
yCount equ ZB0
xOffset equ ZB1
; sourceOffset equ ZB2
; destinationOffset equ ZB3

VramTop equ Vram+VramRowSize*2
ToNextRow equ VramRowSize-VVramWidth

dseg
Backup:
    defs VVramWidth*VVramHeight

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #high Vram | sta ClearScreen_st+1+1
        lda #0 | sta ClearScreen_st+1
        ldx #VramHeight
        do
            ldy #0
            do
                ClearScreen_st:
                sta Vram
                inc ClearScreen_st+1
            while ne | wend
            inc ClearScreen_st+1+1
            dex
        while ne | wend

        lda #low Backup | sta <pBackup
        lda #high Backup | sta <pBackup+1
        ldx #VVramHeight
        do
            lda #0
            ldy #0
            do
                sta (<pBackup),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pBackup | clc|adc #VVramWidth | sta <pBackup
            lda <pBackup+1 | adc #0 | sta <pBackup+1
            dex
        while ne | wend
    pla
rts


cseg
Put1:
    sta <pSource
    lda #0 | sta <pSource+1
    asl <pSource | rol <pSource+1 ; *2
    asl <pSource | rol <pSource+1 ; *4
    asl <pSource | rol <pSource+1 ; *8
    lda <pSource | clc|adc #low Chars_ | sta <pSource
    lda <pSource+1 | adc #high Chars_ sta <pSource+1
    jsr WaitVSync
    ldy #0
    do
        lda (<pSource),y | iny
        Put1_st:
        sta Vram
        lda Put1_st+1 | clc|adc #VramWidth | sta Put1_st+1
        cpy #CharHeight
    while ne | wend
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put_: public Put_
    pha
        lda Put_pVram | sta Put1_st+1
        lda Put_pVram+1 | sta Put1_st+1+1
        
        lda Put_c
        jsr Put1

        ldy Put_pVram | iny
        ldx Put_pVram+1
    pla
rts


; void VVramToVram();
zseg
cseg
VVramToVram_: public VVramToVram_
    pha
        lda #low VVram_ | sta <pVVram
        lda #high VVram_ | sta <pVVram+1

        lda #low Backup | sta <pBackup
        lda #high Backup | sta <pBackup+1

        lda #high VramTop | sta Put1_st+1+1

        lda #VVramHeight | sta <yCount
        do
            ldy #0 | sty Put1_st+1
            do
                lda (<pVVram),y
                cmp (<pBackup),y
                if ne
                    sta (<pBackup),y
                    sty <xOffset
                    jsr Put1
                    ldy <xOffset
                endif
                inc Put1_st+1
                iny
                cpy #VVramWidth
            while ne | wend
            inc Put1_st+1+1

            lda <pVVram | clc | adc #low VVramWidth | sta <pVVram
            lda <pVVram+1 | adc #high VVramWidth | sta <pVVram+1

            lda <pBackup | clc | adc #low VVramWidth | sta <pBackup
            lda <pBackup+1 | adc #high VVramWidth | sta <pBackup+1

            dec <yCount
        while ne | wend
    pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_c:	defs 1
cseg
CharTable:
    defb " -0123456789ACEFGHIKMNOPRSTUVY"
PrintC_: public PrintC_
    pha
        lda PrintC_@Param1
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #30
        while ne | wend
        ldx #0
        PrintC_exit:        
        lda PrintC_pVram | sta Put1_st+1
        lda PrintC_pVram+1 | sta Put1_st+1+1
        txa
        jsr Put1
        ldy PrintC_pVram | iny
        ldx PrintC_pVram+1
    pla
rts